#include "delay.h"
#include "board.h"

void tpu_setup(void)
{
	u32 sr, cr;

	sr = read32(CPG_MSTPSR1);
	if (sr & CPG_MSTP1_TMU0) {
		cr = read32(CPG_SMSTPCR1);
		write32(CPG_SMSTPCR1, cr & ~CPG_MSTP1_TMU0);
	}
	while (read32(CPG_MSTPSR1) & CPG_MSTP1_TMU0);
}

void udelay(u32 usecs)
{
	u32 count;
	u8 tstr;

	/* SUB = 10MHz, TCNT_CLK = 2.5MHz */
	count = (2 * usecs) + ((usecs + 1) / 2);

	write16(TMU(0, TCR), 0);
	write32(TMU(0, TCOR), count);
	write32(TMU(0, TCNT), count);

	tstr = read8(TMU_TSTR0);
	write8(TMU_TSTR0, tstr | 0x1);
	while (!(read16(TMU(0, TCR)) & 0x100));
	write16(TMU(0, TCR), 0x0000);
	tstr = read8(TMU_TSTR0);
	write8(TMU_TSTR0, tstr & ~0x1);
}

void mdelay(u32 msecs)
{
	while (msecs--)
		udelay(1000);
}
